/* 
 * Much of this code was shamelessly ripped out of madplayer and
 * minimad.
 *
 */


#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <mad.h>
#include <ao/ao.h>
#include <netdb.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <signal.h>
#include <unistd.h>
#include <pthread.h>
#include <string.h>
#include <assert.h>
#include <errno.h>

#define HOSTNAME "listen.fm4.amd.co.at"
#define PORT 31337
#define MAXSIZE 8192

#define BUF_SIZE 4096
#define MPEG_BUFSZ 400000

int stop_flag = 0;

char pcmout[4096];		/* take 4k out of the data segment, not the stack */

char buf[MPEG_BUFSZ];
ao_sample_format format;

struct mad_decoder decoder;
    int default_driver;

#define INFO "MP3 Module"

char *plugin_info(void)
{
    return INFO;
}

int input_plugin(void)
{
    return 1;
}

char* input_type(void)
{
    return "mp3";
}

ao_device *device = 0;

FILE *file;
int eof = 0;

void *play(void *);


struct input {
	unsigned char *data;
	unsigned long length;
	int fd;
	int eof;
};

struct input inp;

struct audio_dither {
	  mad_fixed_t error[3];
	    mad_fixed_t random;
};

static inline
unsigned long prng(unsigned long state)
{
  return (state * 0x0019660dL + 0x3c6ef35fL) & 0xffffffffL;
}

inline
signed long audio_linear_dither(unsigned int bits, mad_fixed_t sample,
                                struct audio_dither *dither)
{
  unsigned int scalebits;
  mad_fixed_t output, mask, random;

  enum {
    MIN = -MAD_F_ONE,
    MAX =  MAD_F_ONE - 1
  };

  /* noise shape */
  sample += dither->error[0] - dither->error[1] + dither->error[2];

  dither->error[2] = dither->error[1];
  dither->error[1] = dither->error[0] / 2;

  /* bias */
  output = sample + (1L << (MAD_F_FRACBITS + 1 - bits - 1));

  scalebits = MAD_F_FRACBITS + 1 - bits;
  mask = (1L << scalebits) - 1;

  /* dither */
  random  = prng(dither->random);
  output += (random & mask) - (dither->random & mask);

  dither->random = random;

  /* clip */
  if (output > MAX) {
    output = MAX;

    if (sample > MAX)
      sample = MAX;
  }
  else if (output < MIN) {
    output = MIN;

    if (sample < MIN)
      sample = MIN;
  }

  /* quantize */
  output &= ~mask;

  /* error feedback */
  dither->error[0] = sample - output;

  /* scale */
  return output >> scalebits;
}

static enum mad_flow input(void *data, struct mad_stream *stream) {

  struct input *input = data;
  int len;

  if (input->eof)
    return MAD_FLOW_STOP;

  if (stream->next_frame) {
    memmove(input->data, stream->next_frame,
	    input->length = &input->data[input->length] - stream->next_frame);
  }

  do {
    len = read(input->fd, input->data + input->length,
	       MPEG_BUFSZ - input->length);
  }
  while (len == -1 && errno == EINTR);

  if (len == -1) {
    error("input", ":read");
    return MAD_FLOW_BREAK;
  }
  else if (len == 0) {
    input->eof = 1;

    assert(MPEG_BUFSZ - input->length >= MAD_BUFFER_GUARD);

    while (len < MAD_BUFFER_GUARD)
      input->data[input->length + len++] = 0;
  }

  mad_stream_buffer(stream, input->data, input->length += len);

  return MAD_FLOW_CONTINUE;

#ifdef XXX
	int n;
	char *b = data;
	
	n = read(0,b,MPEG_BUFSZ);

	if (n<=0) return MAD_FLOW_STOP;

	mad_stream_buffer(stream, b, n);

	return MAD_FLOW_CONTINUE;
#endif
}


static inline
signed int scale(mad_fixed_t sample)
{
  /* round */
  sample += (1L << (MAD_F_FRACBITS - 16));

  /* clip */
  if (sample >= MAD_F_ONE)
    sample = MAD_F_ONE - 1;
  else if (sample < -MAD_F_ONE)
    sample = -MAD_F_ONE;

  /* quantize */
  return sample >> (MAD_F_FRACBITS + 1 - 16);
}

static
enum mad_flow output(void *data,
		     struct mad_header const *header,
		     struct mad_pcm *pcm)
{

  unsigned int nchannels, nsamples;
  mad_fixed_t const *left_ch, *right_ch;
  static unsigned char stream[1152*4];

  register signed int sample;
  register mad_fixed_t tempsample;

  static struct audio_dither dither;
  register char * ptr = stream;

  left_ch = pcm->samples[0];
  right_ch = pcm->samples[1];
  nsamples = pcm->length;


    /* Throw the comments plus a few lines about the bitstream we're
       decoding */
    if (!device) {
	format.bits = 16;	// XXX
	format.channels = pcm->channels;
	format.rate = pcm->samplerate;
	format.byte_format = AO_FMT_LITTLE;

    device = ao_open_live(default_driver, &format, NULL /* no options */ );
    }
  
        while (nsamples--)
        {
            tempsample = (mad_fixed_t)((*left_ch++));
            sample = (signed int) audio_linear_dither(16, tempsample, &dither);

            *ptr++ = (unsigned char) (sample >> 0);
            *ptr++ = (unsigned char) (sample >> 8);
            
            tempsample = (mad_fixed_t)((*right_ch++));
            sample = (signed int) audio_linear_dither(16, tempsample, &dither);
            *ptr++ = (unsigned char) (sample >> 0);
            *ptr++ = (unsigned char) (sample >> 8);
        }

        ao_play(device, stream, pcm->length * 4);

  return MAD_FLOW_CONTINUE;
}

static
enum mad_flow derror(void *data,
		    struct mad_stream *stream,
		    struct mad_frame *frame)
{

  fprintf(stderr, "decoding error\n");

	/*
  fprintf(stderr, "decoding error 0x%04x (%s) at byte offset %u\n",
	  stream->error, mad_stream_errorstr(stream),
	  stream->this_frame - buffer->start);
	  */

  /* return MAD_FLOW_BREAK here to stop decoding (and propagate an error) */

  return MAD_FLOW_CONTINUE;
}

int start(char *url)
{

    int s;
    struct hostent *he;
    struct sockaddr_in remote_addr;
    int n, c, last, last2;


    char *buffer;
    int buf_size;
    int sample;
    float freq = 880.0;
    int i;
    char *t,*url_host,*url_port,*url_file;

    ao_sample_format format;
    pthread_t thread;

    url_port = url_host = url_file = 0;

    fprintf(stderr,"## %s ##\n",url);

    /* The following is most likely incredibly buggy, riddled with
     * buffer overruns and should not be used under any circumstances.
     * I just wanted it to work quickly. You have been warned. 
     */

    if (strncmp(url,"http://",7)) {
	    fprintf(stderr,"Not a url\n");
	    return 0;
    }

    t = index(url+7,':');

    if (!t) {
	    url_host = strdup(url+7);
	    url_port = strdup("80");
	    url_file = strdup("/");
    } else {
	    char *u;

	    url_host = (char *) malloc (sizeof(char) * (t-url-6));
	    strncpy(url_host,url+7,t-url-7);
	    url_host[t-url-7]=0;

	    u = index(t,'/');

	    if (!u) {
		    url_port=strdup(t+1);
		    url_file=strdup("/");
	    } else {
    	    	    fprintf(stderr,"C\n");
		    url_port = (char *) malloc (sizeof(char) * (u-t));
		    strncpy(url_port,t+1,u-t-1);
		    url_port[u-t-1]=0;

		    url_file = strdup(u);
	    }
    }

    fprintf(stderr,"Host: %s\n",url_host);
    fprintf(stderr,"Port: %s\n",url_port);
    fprintf(stderr,"File: %s\n",url_file);

    stop_flag = 0;

    s = socket(AF_INET, SOCK_STREAM, 0);


    he = gethostbyname(url_host);

    remote_addr.sin_family = AF_INET;
    remote_addr.sin_port = htons(atoi(url_port));
    remote_addr.sin_addr = *((struct in_addr *) he->h_addr);
    memset(&(remote_addr.sin_zero), '\0', 8);

    connect(s, (struct sockaddr *) &remote_addr, sizeof(struct sockaddr));

    send(s, "GET ", 4, 0);
    send(s, url_file, strlen(url_file), 0);
    send(s, " HTTP/1.0\r\n\r\n", 13, 0);

    file = fdopen(s, "r");


    while ((c = fgetc(file)) != EOF) {
	if (last2 == 13 && last == 10 && c == 13)
	    break;
	/*
	   if (c == 13) { printf("[CR]"); continue; }
	   printf("%c",c);
	   if (c == 10) printf("[LF]");
	 */
	last2 = last;
	last = c;
    }



    inp.fd = s;
    inp.data = buf;
    inp.eof = 0;
    inp.length = 0;

    ao_initialize();
    default_driver = ao_default_driver_id();

    mad_decoder_init(&decoder, &inp, input, 0, 0, output, derror, 0);

    mad_decoder_run(&decoder, MAD_DECODER_MODE_ASYNC);

    pthread_create(&thread,NULL,play,0);

/*
    signal(SIGALRM,play);
    alarm(1);
*/

    if (url_host) free(url_host);
    if (url_port) free(url_port);
    if (url_file) free(url_file);

    return 1;
}

void *play(void *threadid)
{
    int current_section;

    while(!stop_flag) {
	    sleep(1);
    }

    mad_decoder_finish(&decoder);

    /* For some odd reason, this makes it crash.
     
    ao_close(device);
    ao_shutdown();
    */

    /* cleanup */
    pthread_exit(NULL);
    return (0);
    
}

int stop(void)
{
	stop_flag = 1;

    fprintf(stderr, "Done.\n");
}

int status(void)
{
	return 7;		// INVALID
}

